
#!/bin/sh
#	This is the POST1 script generated through XSL for BUILDID: 1000

#
#	Required local variables
#
nPost=0
exit_status=0
slot=0
slot_message=""
blade=
logFile=/tmp/post1Log

#
#	getPlatform() function
#
getPlatform()
{
#
#	Should be pizzabox
#
if [ $1 == 0 ]
then
_abc=`/sbin/sin | \
    /bin/grep Platform | \
    /usr/bin/cut -d" " -f2 | \
    /usr/bin/cut -d"," -f1`

case $_abc in

"SWBD1001" )
blade="MERCURY_MM"
;;

"SWBD1001" )
blade="MERCURY_MM"
;;

"SWBD1000" )
blade="MERCURY_MM"
;;

"SWBD1003" )
blade="MERCURY_SFM"
;;

"SWBD1004" )
blade="MERCURY_LC48x10G"
;;

"SWBD1005" )
blade="MERCURY_LC12x40G"
;;

"SWBD1006" )
blade="MERCURY_LC72x1G"
;;

"SWBD1007" )
blade="MERCURY_LC48x1G"
;;

"SWBD1009" )
blade="MERCURY_LC6x100G"
;;

"SWBD1010" )
blade="MERCURY_LC27x40G"
;;

"SWBD1011" )
blade="MERCURY_LC48x10GT"
;;

* )
blade="UNKNOWN"
;;
esac

else
#
#	Should be chassis
#
case $2 in

"112" )
blade="MERCURY_MM"
;;

"112" )
blade="MERCURY_MM"
;;

"112" )
blade="MERCURY_MM"
;;

"113" )
blade="MERCURY_SFM"
;;

"114" )
blade="MERCURY_LC48x10G"
;;

"127" )
blade="MERCURY_LC12x40G"
;;

"128" )
blade="MERCURY_LC72x1G"
;;

"131" )
blade="MERCURY_LC48x1G"
;;

"149" )
blade="MERCURY_LC6x100G"
;;

"150" )
blade="MERCURY_LC27x40G"
;;

"151" )
blade="MERCURY_LC48x10GT"
;;

* )
blade="UNKNOWN"
;;
esac

fi
}

#
#	Post_cleanup() function
#
post_cleanup()
{
    if [ $?child ]
    then
        /bin/kill $child
    fi

    #
    #  display all performed test result
    #
    _current_time=`/bin/date \+\%s`
    _date=`/bin/date`
    _duration=`/usr/bin/expr $_current_time - $startTime`
    _minute=`/usr/bin/expr $_duration / 60`
    _hour=`/usr/bin/expr $_minute / 60`
    _sec=`/usr/bin/expr $_duration % 60`
    _minute=`/usr/bin/expr $_minute % 60`
    /bin/echo "POST1:$slot_message POST1 script has been ABORTED $_date took ($_hour:$_minute:$_sec)"
    /bin/echo "POST1:$slot_message POST1 script has been ABORTED $_date took ($_hour:$_minute:$_sec)" >> $logFile.$slot
    /bin/echo "POST1:$slot_message Completed totally $nPost diagnostic tests..."
    /bin/echo "POST1:$slot_message Completed totally $nPost diagnostic tests..." >> $logFile.$slot
    if [ $blade = BLACKBIRD ]; then
             $smmi -reg DIAG_STATUS_ID -data POST_FAILINIT; fi
    if [ $blade = TOUCAN ]; then
             $smmi -reg DIAG_STATUS_ID -data POST_FAILINIT; fi
    exit 1
}

#
#	checkStatus of the command and setup exit_status variable
#
checkStatus()
{
    export child=$!
    wait $child
    rval=$?

    case $rval in
    0 )
        status=PASSED
        ;;
    * )
        status=FAILED
        exit_status=`/usr/bin/expr $exit_status + 1`
        if [ $blade = BLACKBIRD ]; then  $smmi -reg DIAG_STATUS_ID -data POST_FAIL1
	    exit $exit_status 
	fi
        if [ $blade = TOUCAN ]; then  $smmi -reg DIAG_STATUS_ID -data POST_FAIL1
	    exit $exit_status 
	fi
        ;;
    esac

    if [ $rval -gt 127 ]
    then
        rval=`/usr/bin/expr $rval - 256`
    fi

    /bin/echo "POST1:$slot_message Test: $* Status: $status (exit_status $rval)..." >> $logFile.$slot
}

trap "" 2
trap post_cleanup INT TERM KILL

#
#	Fill slot variable from FABOS_SLOTNO
#
if [ $?FABOS_SLOTNO ]
then
    slot=$FABOS_SLOTNO
fi

#
#   Fill bladeId variable from Param passed
#
if [ -n "$1" ]
then
    bladeId=$1
fi
/bin/echo "POST1:Bladeid param is $bladeId" >>$logFile.$slot
#
#	Identify blade here
#
getPlatform $slot $bladeId

#
#	Cleanup the old log file
#
if [ -f $logFile.$slot ]
then
	/bin/rm $logFile.$slot
fi

if [ $blade = UNKNOWN ]; then
	/bin/echo "POST1: Blade is UNKNOWN Slot=$slot Blade=$blade " >> $logFile.$slot
    #   Skip running test on unknown blade and enable diagd to transition the blade
    exit 0
fi

#
#   Export Environment variables
#
DIAG_POST=1 ; export DIAG_POST
DIAG_USR_FAILLIM=1 ; export DIAG_USR_FAILLIM

#
#	Sourcing diagcommon.sh
#
home="/fabos/share"
util="diagcommon.sh"
ok=0
for f in "./$util" "$FABOSHOME/share/$util" "$home/$util" ; do
    if [ -r $f ] ; then
        . $f
        ok=1
        break;
    fi
done
if [ $ok -ne 1 ] ; then
	/bin/echo "POST1: Could not locate $util; Aborting"
	/bin/echo "POST1: Could not locate $util; Aborting" >> $logFile.$slot
	exit 3
fi

#
#	Check Pizzabox/Chassis variant during runtime; isMultiBlade is defined in diagcommon.sh
#	Also setup slot_message variable
#
multiBlade=`isMultiBlade`
if [ $multiBlade = TRUE ]
then
	slot_message="Slot `get_logical_slot $slot`"
	export syntax="$0 -slot [slot] essScript"
else
	export syntax="$0 essScript"
fi

#
#	Add blade identifiers to our Log file for debugging purpose; Zero means pizzabox
#
/bin/echo "POST1:$slot_message running for platform: $blade, Slot#: $slot, Logfile: $logFile"  >> $logFile.$slot

#
#	Setup commandPaths
#
cmd=`commandPath exec_diag`
setdbg=`commandPath setdbg`

if [ $blade = BLACKBIRD ]; then
smmi=`commandPath setmmi`
gmmi=`commandPath getmmi`

state=`$gmmi -reg "POST CONFIG"| cut -d" " -f2`
case $state in
         0 | 1 ) exit 0;;
	 *) ;;
esac
fi

if [ $blade = TOUCAN ]; then
smmi=`commandPath setmmi`
gmmi=`commandPath getmmi`

state=`$gmmi -reg "POST CONFIG"| cut -d" " -f2`
case $state in
         0 | 1 ) exit 0;;
	 *) ;;
esac
fi

$setdbg DIAG 1

#
#       Start message to the user
#
startTime=`/bin/date \+\%s`
_date=`/bin/date`
/bin/echo "" >> $logFile.$slot
/bin/echo "POST1:$slot_message started running $_date"
/bin/echo "POST1:$slot_message started running $_date" >> $logFile.$slot

#
#	Reset Error on each port 
# 
/bin/echo "POST1:$slot_message Clearing errors" >> $logFile.$slot
$cmd diagclearerror $slot > /dev/null

#
#	Execute command-set as per platform
#
case $blade in




#
#	Platform: Platform name not found
#
" " )
echo "POST1 Script error: Could not determine blade (Parameters: Slot=$slot, Blade=$blade). Aborting" >> $logFile.$slot
exit 4
;;


#
#	Platform: MERCURY_SFM
#
"MERCURY_SFM" ) 

#
#   Test: Setupfortest
#

cmd3=`commandPath exec_diag`

/bin/echo "POST1:$slot_message Test - Running Setupfortest (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 2 -post 1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
	exit_status=`/usr/bin/expr $exit_status + 1`
fi

#
#   Test: Turboramtest
#

cmd3=`commandPath exec_diag`

if [ -f "/tmp/diagEnableBist" ]
then

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest" >> $logFile.$slot
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest"
$cmd3 turboramtest 2>&1 >> $logFile.$slot &
checkStatus turboramtest 2>&1
fi

;;

#
#	Platform: MERCURY_LC48x10G
#
"MERCURY_LC48x10G" ) 

#
#   Test: Setupfortest
#

cmd3=`commandPath exec_diag`

/bin/echo "POST1:$slot_message Test - Running Setupfortest (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 2 -post 1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
	exit_status=`/usr/bin/expr $exit_status + 1`
fi

#
#   Test: Turboramtest
#

cmd3=`commandPath exec_diag`

if [ -f "/tmp/diagEnableBist" ]
then

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest" >> $logFile.$slot
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest"
$cmd3 turboramtest 2>&1 >> $logFile.$slot &
checkStatus turboramtest 2>&1
fi

;;

#
#	Platform: MERCURY_LC12x40G
#
"MERCURY_LC12x40G" ) 

#
#   Test: Setupfortest
#

cmd3=`commandPath exec_diag`

/bin/echo "POST1:$slot_message Test - Running Setupfortest (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 2 -post 1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
	exit_status=`/usr/bin/expr $exit_status + 1`
fi

#
#   Test: Turboramtest
#

cmd3=`commandPath exec_diag`

if [ -f "/tmp/diagEnableBist" ]
then

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest" >> $logFile.$slot
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest"
$cmd3 turboramtest 2>&1 >> $logFile.$slot &
checkStatus turboramtest 2>&1
fi

;;

#
#	Platform: MERCURY_LC72x1G
#
"MERCURY_LC72x1G" ) 

#
#   Test: Setupfortest
#

cmd3=`commandPath exec_diag`

/bin/echo "POST1:$slot_message Test - Running Setupfortest (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 2 -post 1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
	exit_status=`/usr/bin/expr $exit_status + 1`
fi

#
#   Test: Turboramtest
#

cmd3=`commandPath exec_diag`

if [ -f "/tmp/diagEnableBist" ]
then

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest" >> $logFile.$slot
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest"
$cmd3 turboramtest 2>&1 >> $logFile.$slot &
checkStatus turboramtest 2>&1
fi

;;

#
#	Platform: MERCURY_LC48x1G
#
"MERCURY_LC48x1G" ) 

#
#   Test: Setupfortest
#

cmd3=`commandPath exec_diag`

/bin/echo "POST1:$slot_message Test - Running Setupfortest (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 2 -post 1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
	exit_status=`/usr/bin/expr $exit_status + 1`
fi

#
#   Test: Turboramtest
#

cmd3=`commandPath exec_diag`

if [ -f "/tmp/diagEnableBist" ]
then

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest" >> $logFile.$slot
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest"
$cmd3 turboramtest 2>&1 >> $logFile.$slot &
checkStatus turboramtest 2>&1
fi

;;

#
#	Platform: MERCURY_LC6x100G
#
"MERCURY_LC6x100G" ) 

#
#   Test: Setupfortest
#

cmd3=`commandPath exec_diag`

/bin/echo "POST1:$slot_message Test - Running Setupfortest (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 2 -post 1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
	exit_status=`/usr/bin/expr $exit_status + 1`
fi

#
#   Test: Turboramtest
#

cmd3=`commandPath exec_diag`

if [ -f "/tmp/diagEnableBist" ]
then

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest" >> $logFile.$slot
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest"
$cmd3 turboramtest 2>&1 >> $logFile.$slot &
checkStatus turboramtest 2>&1
fi

;;

#
#	Platform: MERCURY_LC27x40G
#
"MERCURY_LC27x40G" ) 

#
#   Test: Setupfortest
#

cmd3=`commandPath exec_diag`

/bin/echo "POST1:$slot_message Test - Running Setupfortest (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 2 -post 1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
	exit_status=`/usr/bin/expr $exit_status + 1`
fi

#
#   Test: Turboramtest
#

cmd3=`commandPath exec_diag`

if [ -f "/tmp/diagEnableBist" ]
then

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest" >> $logFile.$slot
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest"
$cmd3 turboramtest 2>&1 >> $logFile.$slot &
checkStatus turboramtest 2>&1
fi

;;

#
#	Platform: MERCURY_LC48x10GT
#
"MERCURY_LC48x10GT" ) 

#
#   Test: Setupfortest
#

cmd3=`commandPath exec_diag`

/bin/echo "POST1:$slot_message Test - Running Setupfortest (Silent)" >> $logFile.$slot
$cmd3 usdsetupfortest --slot $slot -test_step 2 -post 1 >> $logFile.$slot
status_local=$?

if [ $status_local -ne 0 ]
then
	exit_status=`/usr/bin/expr $exit_status + 1`
fi

#
#   Test: Turboramtest
#

cmd3=`commandPath exec_diag`

if [ -f "/tmp/diagEnableBist" ]
then

nPost=`/usr/bin/expr $nPost + 1`
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest" >> $logFile.$slot
/bin/echo "POST1:$slot_message Test #$nPost - Running Turboramtest"
$cmd3 turboramtest 2>&1 >> $logFile.$slot &
checkStatus turboramtest 2>&1
fi

;;

esac

#
#	Display completed test count
#
/bin/echo "POST1:$slot_message Completed totally $nPost diagnostic tests..." >> $logFile.$slot

#
#	If exit_status > 0, report FAILED
#
if [ $exit_status -ne 0 ]
then
    status=FAILED
    #	copy the POST log to permanent storage for FA
    /fabos/link_bin/sync
    /bin/cp $logFile.$slot /var/log
    /fabos/link_bin/sync
else
    status=PASSED
fi

#
#	Display final exit_status
#
_current_time=`/bin/date \+\%s`
_date=`/bin/date`
_duration=`/usr/bin/expr $_current_time - $startTime`
_minute=`/usr/bin/expr $_duration / 60`
_hour=`/usr/bin/expr $_minute / 60`
_sec=`/usr/bin/expr $_duration % 60`
_minute=`/usr/bin/expr $_minute % 60`
/bin/echo "POST1:$slot_message Script $status with exit status of $exit_status $_date took ($_hour:$_minute:$_sec)"
/bin/echo "POST1:$slot_message Script $status with exit_status of $exit_status $_date took ($_hour:$_minute:$_sec)" >> $logFile.$slot
/bin/echo "" >> $logFile.$slot

#
#	Return with the error code (Zero shows no error)
#
exit $exit_status
